// 004 u_c_display_packets
// 30 oct 2007

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit a_aa_22_blackfish_db;

interface

uses
  System.Collections, System.ComponentModel,
  System.Data, System.Drawing, System.Web, System.Web.SessionState,
  System.Web.UI, System.Web.UI.WebControls, System.Web.UI.HtmlControls,
  System.Web.Security, System.Web.UI.WebControls.WebParts, System.Configuration
  , Borland.Data.DataStore
  ;

type
  TDefault = class(System.Web.UI.Page)
  {$REGION 'Designer Managed Code'}
  strict private
    procedure InitializeComponent;
    procedure connect_jds_an_remote__Click(sender: TObject; e: System.EventArgs);
    procedure display_datareader__Click(sender: TObject; e: System.EventArgs);
    procedure datastore_connect__Click(sender: TObject; e: System.EventArgs);
    procedure fill_and_databiind__Click(sender: TObject; e: System.EventArgs);
  {$ENDREGION}
  strict private
    procedure Page_Load(sender: System.Object; e: System.EventArgs);
  strict protected
    connect_jds_an_remote_: System.Web.UI.WebControls.Button;
    TextBox1: System.Web.UI.WebControls.TextBox;
    display_datareader_: System.Web.UI.WebControls.Button;
    DataStoreConnection1: Borland.Data.DataStore.DataStoreConnection;
    datastore_connect_: System.Web.UI.WebControls.Button;
    DataStoreSelectCommand1: Borland.Data.DataStore.DataStoreCommand;
    DataStoreInsertCommand1: Borland.Data.DataStore.DataStoreCommand;
    DataStoreUpdateCommand1: Borland.Data.DataStore.DataStoreCommand;
    DataStoreDeleteCommand1: Borland.Data.DataStore.DataStoreCommand;
    DataStoreDataAdapter1: Borland.Data.DataStore.DataStoreDataAdapter;
    DataSet1: System.Data.DataSet;
    fill_and_databiind_: System.Web.UI.WebControls.Button;
    ListBox1: System.Web.UI.WebControls.ListBox;
    SqlDataSource1: System.Web.UI.WebControls.SqlDataSource;
    GridView1: System.Web.UI.WebControls.GridView;
  protected
    procedure OnInit(e: EventArgs); override;
  private
  public
    procedure display(p_text: String);
  end;

implementation
  uses System.Data.Common
      ;

{$REGION 'Designer Managed Code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TDefault.InitializeComponent;
begin
  Self.DataStoreConnection1 := Borland.Data.DataStore.DataStoreConnection.Create;
  Self.DataStoreSelectCommand1 := Borland.Data.DataStore.DataStoreCommand.Create;
  Self.DataStoreInsertCommand1 := Borland.Data.DataStore.DataStoreCommand.Create;
  Self.DataStoreUpdateCommand1 := Borland.Data.DataStore.DataStoreCommand.Create;
  Self.DataStoreDeleteCommand1 := Borland.Data.DataStore.DataStoreCommand.Create;
  Self.DataStoreDataAdapter1 := Borland.Data.DataStore.DataStoreDataAdapter.Create;
  Self.DataSet1 := System.Data.DataSet.Create;
  (System.ComponentModel.ISupportInitialize(Self.DataStoreDataAdapter1)).BeginInit;
  (System.ComponentModel.ISupportInitialize(Self.DataSet1)).BeginInit;
  Include(Self.connect_jds_an_remote_.Click, Self.connect_jds_an_remote__Click);
  Include(Self.display_datareader_.Click, Self.display_datareader__Click);
  Include(Self.datastore_connect_.Click, Self.datastore_connect__Click);
  Include(Self.fill_and_databiind_.Click, Self.fill_and_databiind__Click);
  // 
  // DataStoreConnection1
  // 
  Self.DataStoreConnection1.ConnectionString := 'host=LocalHost;database=C:\' +
  'programs\us\web\asp_net\asp_net_20_ado_net\_data\employee_2.jds;user=SYSD' +
  'BA;password=masterkey;protocol=TCP';
  // 
  // DataStoreSelectCommand1
  // 
  Self.DataStoreSelectCommand1.CommandText := 'SELECT * FROM COUNTRY';
  Self.DataStoreSelectCommand1.CommandTimeout := 0;
  Self.DataStoreSelectCommand1.Connection := Self.DataStoreConnection1;
  // 
  // DataStoreInsertCommand1
  // 
  Self.DataStoreInsertCommand1.CommandText := 'INSERT INTO "COUNTRY" ("COUNT' +
  'RY", "CURRENCY") VALUES (:COUNTRY, :CURRENCY)';
  Self.DataStoreInsertCommand1.CommandTimeout := 0;
  Self.DataStoreInsertCommand1.Connection := Self.DataStoreConnection1;
  Self.DataStoreInsertCommand1.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create('C' +
      'OUNTRY', Borland.Data.DataStore.JDSType.VarChar, System.Data.ParameterDirection.Input, 
        'COUNTRY', System.Data.DataRowVersion.Current));
  Self.DataStoreInsertCommand1.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create('C' +
      'URRENCY', Borland.Data.DataStore.JDSType.VarChar, System.Data.ParameterDirection.Input, 
        'CURRENCY', System.Data.DataRowVersion.Current));
  // 
  // DataStoreUpdateCommand1
  // 
  Self.DataStoreUpdateCommand1.CommandText := 'UPDATE "COUNTRY" SET "COUNTRY' +
  '" = :COUNTRY, "CURRENCY" = :CURRENCY WHERE (("COUNTRY" = :Original_COUNTR' +
  'Y) AND ((:IsNull_CURRENCY = 1 AND "CURRENCY" IS NULL) OR ("CURRENCY" = :O' +
  'riginal_CURRENCY)))';
  Self.DataStoreUpdateCommand1.CommandTimeout := 0;
  Self.DataStoreUpdateCommand1.Connection := Self.DataStoreConnection1;
  Self.DataStoreUpdateCommand1.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create('C' +
      'OUNTRY', Borland.Data.DataStore.JDSType.VarChar, System.Data.ParameterDirection.Input, 
        'COUNTRY', System.Data.DataRowVersion.Current));
  Self.DataStoreUpdateCommand1.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create('C' +
      'URRENCY', Borland.Data.DataStore.JDSType.VarChar, System.Data.ParameterDirection.Input, 
        'CURRENCY', System.Data.DataRowVersion.Current));
  Self.DataStoreUpdateCommand1.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create('O' +
      'riginal_COUNTRY', Borland.Data.DataStore.JDSType.VarChar, System.Data.ParameterDirection.Input, 
        'COUNTRY', System.Data.DataRowVersion.Original));
  Self.DataStoreUpdateCommand1.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create('I' +
      'sNull_CURRENCY', Borland.Data.DataStore.JDSType.Int, System.Data.ParameterDirection.Input, 
        'CURRENCY', System.Data.DataRowVersion.Original));
  Self.DataStoreUpdateCommand1.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create('O' +
      'riginal_CURRENCY', Borland.Data.DataStore.JDSType.VarChar, System.Data.ParameterDirection.Input, 
        'CURRENCY', System.Data.DataRowVersion.Original));
  // 
  // DataStoreDeleteCommand1
  // 
  Self.DataStoreDeleteCommand1.CommandText := 'DELETE FROM "COUNTRY" WHERE (' +
  '("COUNTRY" = :Original_COUNTRY) AND ((:IsNull_CURRENCY = 1 AND "CURRENCY"' +
  ' IS NULL) OR ("CURRENCY" = :Original_CURRENCY)))';
  Self.DataStoreDeleteCommand1.CommandTimeout := 0;
  Self.DataStoreDeleteCommand1.Connection := Self.DataStoreConnection1;
  Self.DataStoreDeleteCommand1.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create('O' +
      'riginal_COUNTRY', Borland.Data.DataStore.JDSType.VarChar, System.Data.ParameterDirection.Input, 
        'COUNTRY', System.Data.DataRowVersion.Original));
  Self.DataStoreDeleteCommand1.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create('I' +
      'sNull_CURRENCY', Borland.Data.DataStore.JDSType.Int, System.Data.ParameterDirection.Input, 
        'CURRENCY', System.Data.DataRowVersion.Original));
  Self.DataStoreDeleteCommand1.Parameters.Add(Borland.Data.DataStore.DataStoreParameter.Create('O' +
      'riginal_CURRENCY', Borland.Data.DataStore.JDSType.VarChar, System.Data.ParameterDirection.Input, 
        'CURRENCY', System.Data.DataRowVersion.Original));
  // 
  // DataStoreDataAdapter1
  // 
  Self.DataStoreDataAdapter1.DataSet := nil;
  Self.DataStoreDataAdapter1.DeleteCommand := Self.DataStoreDeleteCommand1;
  Self.DataStoreDataAdapter1.InsertCommand := Self.DataStoreInsertCommand1;
  Self.DataStoreDataAdapter1.SelectCommand := Self.DataStoreSelectCommand1;
  Self.DataStoreDataAdapter1.UpdateCommand := Self.DataStoreUpdateCommand1;
  // 
  // DataSet1
  // 
  Self.DataSet1.DataSetName := 'NewDataSet';
  Include(Self.Load, Self.Page_Load);
  (System.ComponentModel.ISupportInitialize(Self.DataStoreDataAdapter1)).EndInit;
  (System.ComponentModel.ISupportInitialize(Self.DataSet1)).EndInit;
end;
{$ENDREGION}

    procedure TDefault.display(p_text: String);
      begin
        TextBox1.Text:= TextBox1.Text+ p_text+ chr(13)+ chr(10);
      end; // display

    procedure TDefault.OnInit(e: EventArgs);
      begin
        InitializeComponent;
        inherited OnInit(e);
      end;

    procedure TDefault.Page_Load(sender: System.Object; e: System.EventArgs);
      begin
        // TODO: Put user code to initialize the page here
      end;

    const k_bfs_anr_provider_name= 'Borland.Data.BlackfishSQL.RemoteClient';
          // k_bfs_anr_connection_name= 'anr_employee_jds';

(*
          k_bfs_bfs_connection_string_1= 'drivername=BLACKFISHSQL;user_name=sysdba;port=2508;create=False;readonlydb=False;hostname=localhost;';
          k_bfs_bfs_connection_string_2= 'database=C:\programs\us\db\blackfishsql\_data\employee.jds';
*)
          // -- taken from Data Explorer + password
          k_bfs_bfs_connection_string= 'host=LocalHost;user=sysdba;database=C:\programs\us\db\blackfishsql\_data\employee.jds'
              + ';password=masterkey';

    procedure TDefault.connect_jds_an_remote__Click(sender: TObject; e: System.EventArgs);
      var l_c_db_provider_factory: DbProviderFactory;
          l_c_db_connection: DbConnection;
      begin
        display('> connect_jds_an_remote');
        l_c_db_provider_factory:= DbProviderFactories.GetFactory(k_bfs_anr_provider_name);

        l_c_db_connection:= l_c_db_provider_factory.CreateConnection();

        // l_c_db_connection.ConnectionString:= 'ConnectionName='+ k_bfs_anr_connection_name;

(*
        l_c_db_connection.ConnectionString:=
            k_bfs_bfs_connection_string_1+ k_bfs_bfs_connection_string_2;
*)
        l_c_db_connection.ConnectionString:= k_bfs_bfs_connection_string;
        l_c_db_connection.Open;
        l_c_db_connection.Close;
        display('< connect_jds_an_remote');
      end; // connect_jds_an_remote__Click

(*
    function f_c_db_connection(p_provider_name, p_connection_string: String): DbConnection;
      var l_c_db_provider_factory: DbProviderFactory;
      begin
        l_c_db_provider_factory:= DbProviderFactories.GetFactory(k_ib_provider_name);
        Result:= l_c_db_provider_factory.CreateConnection();
        Result.ConnectionString:= k_ib_connection_string_1+ k_ib_connection_string_2;
      end; // f_c_db_connection
*)

    procedure TDefault.display_datareader__Click(sender: TObject; e: System.EventArgs);
      var l_c_db_provider_factory: DbProviderFactory;
          l_c_db_connection: DbConnection;
          l_c_db_command: DbCommand;
          l_c_db_datareader: DbDataReader;

          l_row_display: String;
          l_column_index: Integer;
      begin
        display('> db_reader');
        l_c_db_provider_factory:= DbProviderFactories.GetFactory(k_bfs_anr_provider_name);
        l_c_db_connection:= l_c_db_provider_factory.CreateConnection();
        // no l_c_db_connection.ConnectionString:= 'ConnectionName='+ k_bfs_anr_connection_name;
        l_c_db_connection.ConnectionString:= k_bfs_bfs_connection_string;

        l_c_db_connection.Open;
        l_c_db_command:= l_c_db_connection.CreateCommand();
        l_c_db_command.CommandText:= 'SELECT * FROM country';

        l_c_db_datareader:= l_c_db_command.ExecuteReader;

        while l_c_db_datareader.Read do
        begin
          l_row_display:= '';
          for l_column_index:= 0 to l_c_db_datareader.FieldCount- 1 do
            l_row_display:= l_row_display
                + l_c_db_datareader.Item[l_column_index].ToString+ ' ';
          display(l_row_display);
        end; // while l_c_db_datareader.Read

        l_c_db_connection.Close;
        display('< db_reader');
      end; // display_datareader__Click

    procedure TDefault.datastore_connect__Click(sender: TObject; e: System.EventArgs);
      begin
        display('> datastore_connect_');
        DataStoreConnection1.ConnectionString:= k_bfs_bfs_connection_string;
        DataStoreConnection1.Open;
        DataStoreConnection1.Close;
        display('< datastore_connect_');
      end; // datastore_connect__Click

    procedure TDefault.fill_and_databiind__Click(sender: TObject; e: System.EventArgs);
      begin
        display('> fill_and_databiind');

        DataStoreDataAdapter1.Fill(DataSet1);
        ListBox1.DataSource:= DataSet1.Tables[0].DefaultView;
        ListBox1.DataTextField:= 'COUNTRY';
        DataBind;

        display('< fill_and_databiind');
      end; // fill_and_databiind__Click

end.




    function f_c_db_datareader(p_c_db_connection: DbConnection;
        p_select_request: String): DbDataReader;
      // -- receives an OPEN connection
      var l_c_db_connection: DbConnection;
          l_c_db_command: DbCommand;
      begin
        l_c_db_command:= p_c_db_connection.CreateCommand();
        l_c_db_command.CommandText:= p_select_request;

        Result:= l_c_db_command.ExecuteReader;
      end; // f_c_db_datareader

    procedure TDefault.fill_listbox__Click(sender: TObject; e: System.EventArgs);
      var l_c_db_provider_factory: DbProviderFactory;
          l_c_db_connection: DbConnection;
          l_c_db_datareader: DbDataReader;

          l_row_display: String;
          l_column_index: Integer;
      begin
        display('> db_reader');
        l_c_db_provider_factory:= DbProviderFactories.GetFactory(k_ib_provider_name);
        l_c_db_connection:= l_c_db_provider_factory.CreateConnection();
        l_c_db_connection.ConnectionString:= k_ib_connection_string_1+ k_ib_connection_string_2;

        l_c_db_connection.Open;

        l_c_db_datareader:= f_c_db_datareader(
            l_c_db_connection, 'SELECT * FROM country');

        ListBox1.DataSource:= l_c_db_datareader;
        ListBox1.DataTextField:= 'COUNTRY';
        DataBind;

        display('< db_reader');
      end; // fill_listbox__Click

